static NSString * const kStat1 = @"1";
static NSString * const kStat2 = @"2";
static NSString * const kStat3 = @"3";
static NSString * const kStat3D = @"3D";
static NSString * const kStat3DBuildings= @"3D buildings";
static NSString * const kStat4 = @"4";
static NSString * const kStat5 = @"5";
static NSString * const kStat6 = @"6";
static NSString * const kStat7 = @"7";
static NSString * const kStat8 = @"8";
static NSString * const kStat9 = @"9";
static NSString * const kStatAPI = @"API";
static NSString * const kStatAbout = @"About";
static NSString * const kStatAction = @"action";
static NSString * const kStatActionSheet = @"Action sheet";
static NSString * const kStatAd = @"Ad";
static NSString * const kStatAdTitle = @"Ad title";
static NSString * const kStatAdd = @"add";
static NSString * const kStatAddPlace = @"Add place";
static NSString * const kStatAfterSave = @"after_save";
static NSString * const kStatAlert = @"Alert";
static NSString * const kStatAllMaps = @"all_maps";
static NSString * const kStatAlways = @"Always";
static NSString * const kStatAny = @"any";
static NSString * const kStatApartment = @"apartment";
static NSString * const kStatApplication = @"Application";
static NSString * const kStatApplicationColdStartupInfo = @"Application_ColdStartup_info";
static NSString * const kStatApply = @"Apply";
static NSString * const kStatAsk = @"Ask";
static NSString * const kStatAttractions = @"Attractions";
static NSString * const kStatAuthorization = @"Authorization";
static NSString * const kStatAutoDownload = @"Auto download";
static NSString * const kStatAutoZoom = @"Autozoom";
static NSString * const kStatBack = @"Back";
static NSString * const kStatBanner = @"banner";
static NSString * const kStatBattery = @"battery";
static NSString * const kStatBicycle = @"Bicycle";
static NSString * const kStatBooking = @"Booking.com";
static NSString * const kStatBookmarkCreated = @"Bookmark. Bookmark created";
static NSString * const kStatBookmarks = @"Bookmarks";
static NSString * const kStatBuildRoute = @"Build route";
static NSString * const kStatButton = @"Button";
static NSString * const kStatCallPhoneNumber = @"Call phone number";
static NSString * const kStatCampSite = @"campSite";
static NSString * const kStatCancel = @"cancel";
static NSString * const kStatCategories = @"Categories";
static NSString * const kStatCategory = @"category";
static NSString * const kStatChalet = @"chalet";
static NSString * const kStatChangeBookmarkColor = @"Change bookmark color";
static NSString * const kStatChangeBookmarkDescription = @"Change bookmark description";
static NSString * const kStatChangeBookmarkGroup = @"Change bookmark group";
static NSString * const kStatChangeLanguage = @"Change language";
static NSString * const kStatChangeMapViewStyle = @"Change map view style";
static NSString * const kStatChangeMeasureUnits = @"Change measure units";
static NSString * const kStatChangeMobileInternet = @"Change mobile internet";
static NSString * const kStatChangeNightMode = @"Change night mode";
static NSString * const kStatChangeRecentTrack = @"Change recent track";
static NSString * const kStatChangeRoutingMode = @"Change routing mode";
static NSString * const kStatCharging = @"charging";
static NSString * const kStatCheckIn = @"check_in";
static NSString * const kStatCheckOut = @"check_out";
static NSString * const kStatCian = @"Cian.ru";
static NSString * const kStatClear = @"Clear";
static NSString * const kStatClose = @"Close";
static NSString * const kStatCollapse = @"Collapse";
static NSString * const kStatCompass = @"Compass";
static NSString * const kStatConnection = @"connection";
static NSString * const kStatCopyright = @"Copyright";
static NSString * const kStatCount = @"Count";
static NSString * const kStatCountry = @"Country";
static NSString * const kStatCurrentMap = @"current_map";
static NSString * const kStatDate = @"date";
static NSString * const kStatDelete = @"delete";
static NSString * const kStatDeleteAll = @"delete all";
static NSString * const kStatDeleteAllWithChanges = @"delete_all_with_changes";
static NSString * const kStatDeleteWithChanges = @"delete_with_changes";
static NSString * const kStatDestination = @"Destination";
static NSString * const kStatDeviceInfo = @"Device info";
static NSString * const kStatDeviceType = @"Device type";
static NSString * const kStatDiscovery = @"discovery";
static NSString * const kStatDiscoveryButtonItemClick = @"DiscoveryButton_Item_Click";
static NSString * const kStatDiscoveryButtonItemShow = @"DiscoveryButton_Item_Show";
static NSString * const kStatDiscoveryButtonOpen = @"DiscoveryButton_Open";
static NSString * const kStatDownload = @"download";
static NSString * const kStatDownloadGroup = @"download_group";
static NSString * const kStatDownloadMap = @"Download map";
static NSString * const kStatDownloadMaps = @"Download maps";
static NSString * const kStatDownloadRequest = @"Download request";
static NSString * const kStatDownloadRoute = @"Download route";
static NSString * const kStatDownloader = @"downloader";
static NSString * const kStatDownloaderDialog = @"Downloader dialog";
static NSString * const kStatDownloaderDownloadCancel = @"Downloader_Download_cancel";
static NSString * const kStatDownloaderMapAction = @"Downloader_Map_action";
static NSString * const kStatDownloaderMapError = @"Downloader_Map_error";
static NSString * const kStatDownloaderMigrationCompleted = @"Downloader_Migration_completed";
static NSString * const kStatDownloaderMigrationDialogue = @"Downloader_Migration_dialogue";
static NSString * const kStatDownloaderMigrationError = @"Downloader_Migration_error";
static NSString * const kStatDownloaderMigrationProhibitedDialogue = @"Downloader_Migration_Prohibited_dialogue";
static NSString * const kStatDownloaderMigrationStarted = @"Downloader_Migration_started";
static NSString * const kStatDownloaderOnStartScreenAutoDownload = @"Downloader_OnStartScreen_auto_download";
static NSString * const kStatDownloaderOnStartScreenCancelDownload = @"Downloader_OnStartScreen_cancel_download";
static NSString * const kStatDownloaderOnStartScreenError = @"Downloader_OnStartScreen_error";
static NSString * const kStatDownloaderOnStartScreenManualDownload = @"Downloader_OnStartScreen_manual_download";
static NSString * const kStatDownloaderOnStartScreenSelectLater = @"Downloader_OnStartScreen_select_later";
static NSString * const kStatDownloaderOnStartScreenShow = @"Downloader_OnStartScreen_show";
static NSString * const kStatEatAndDrink = @"Eat and drink";
static NSString * const kStatEdit = @"Edit";
static NSString * const kStatEditTime = @"Edit time";
static NSString * const kStatEditorAddCancel = @"Editor_Add_cancel";
static NSString * const kStatEditorAddClick = @"Editor_Add_click";
static NSString * const kStatEditorAddError = @"Editor_Add_error";
static NSString * const kStatEditorAddStart = @"Editor_Add_start";
static NSString * const kStatEditorAddSuccess = @"Editor_Add_success";
static NSString * const kStatEditorAuthDeclinedByUser = @"Editor_Auth_declined_by_user";
static NSString * const kStatEditorAuthRequets = @"Editor_Auth_request";
static NSString * const kStatEditorEditCancel = @"Editor_Edit_cancel";
static NSString * const kStatEditorEditError = @"Editor_Edit_error";
static NSString * const kStatEditorEditStart = @"Editor_Edit_start";
static NSString * const kStatEditorEditSuccess = @"Editor_Edit_success";
static NSString * const kStatEditorMWMName = @"mwm_name";
static NSString * const kStatEditorMWMVersion = @"mwm_version";
static NSString * const kStatEditorProblemReport = @"Editor_Problem_report";
static NSString * const kStatEditorRegRequest = @"Editor_Reg_request";
static NSString * const kStatEditorSecondTimeShareClick = @"Editor_SecondTimeShare_click";
static NSString * const kStatEditorSecondTimeShareShow = @"Editor_SecondTimeShare_show";
static NSString * const kStatError = @"Error";
static NSString * const kStatErrorCode = @"error_code";
static NSString * const kStatErrorData = @"err_data";
static NSString * const kStatErrorMessage = @"error_message";
static NSString * const kStatExpand = @"Expand";
static NSString * const kStatExpandCategory = @"Expand category";
static NSString * const kStatExpandLargeCountry = @"Expand large country";
static NSString * const kStatExplore = @"Explore";
static NSString * const kStatExport = @"Export";
static NSString * const kStatExternal = @"external";
static NSString * const kStatFacebook = @"Facebook";
static NSString * const kStatFeedback = @"Feedback";
static NSString * const kStatFrom = @"from";
static NSString * const kStatFromLocation = @"from_location";
static NSString * const kStatFromMyPosition = @"From my position";
static NSString * const kStatGo = @"Go";
static NSString * const kStatGoogle = @"Google";
static NSString * const kStatGuestHouse = @"guestHouse";
static NSString * const kStatHelp = @"Help";
static NSString * const kStatHidden = @"Hidden";
static NSString * const kStatHistory = @"History";
static NSString * const kStatHoliday = @"Holiday";
static NSString * const kStatHostel = @"hostel";
static NSString * const kStatHotel = @"hotel";
static NSString * const kStatHotelLocation = @"hotel_location";
static NSString * const kStatImport = @"Import";
static NSString * const kStatIn = @"In";
static NSString * const kStatIsAuthenticated = @"is_authenticated";
static NSString * const kStatIsAuto = @"is_auto";
static NSString * const kStatIsOnline = @"is_online";
static NSString * const kStatIsSuccess = @"is_success";
static NSString * const kStatItem = @"item";
static NSString * const kStatKML = @"KML";
static NSString * const kStatKilometers = @"Kilometers";
static NSString * const kStatLandscape = @"Landscape";
static NSString * const kStatLanguage = @"Language";
static NSString * const kStatLocals = @"Locals";
static NSString * const kStatLocalsProvider = @"Locals.Maps.Me";
static NSString * const kStatLocation = @"Location";
static NSString * const kStatLogout = @"Logout";
static NSString * const kStatMap = @"map";
static NSString * const kStatMapDataSize = @"map_data_size";
static NSString * const kStatMapSearch = @"Map search";
static NSString * const kStatMapViewStyle = @"Map view style";
static NSString * const kStatMapViewStyleSettings = @"Map view style settings";
static NSString * const kStatMenu = @"Menu";
static NSString * const kStatMigrationBig2SmallMWM = @"Big mwms to small mwms migration counter";
static NSString * const kStatMiles = @"Miles";
static NSString * const kStatMobile = @"mobile";
static NSString * const kStatMobileInternet = @"Mobile Internet";
static NSString * const kStatMode = @"mode";
static NSString * const kStatMopub = @"Mopub";
static NSString * const kStatMoreApps = @"More apps";
static NSString * const kStatMotel = @"motel";
static NSString * const kStatMyPosition = @"My position";
static NSString * const kStatMyTargetAppsClicked = @"MyTargetAppsClicked";
static NSString * const kStatMyTargetAppsDisplayed = @"MyTargetAppsDisplayed";
static NSString * const kStatName = @"Name";
static NSString * const kStatNavigationDashboard = @"Navigation dashboard";
static NSString * const kStatNetwork = @"network";
static NSString * const kStatNever = @"Never";
static NSString * const kStatNext = @"Next";
static NSString * const kStatNightMode = @"NightMode";
static NSString * const kStatNo = @"No";
static NSString * const kStatNone = @"none";
static NSString * const kStatNoConnection = @"no_connection";
static NSString * const kStatNoSpace = @"no_space";
static NSString * const kStatOSM = @"OSM";
static NSString * const kStatOSMUserName = @"osm_username";
static NSString * const kStatObjectLat = @"object_lat";
static NSString * const kStatObjectLon = @"object_lon";
static NSString * const kStatOff = @"Off";
static NSString * const kStatOffline = @"offline";
static NSString * const kStatOn = @"On";
static NSString * const kStatOnline = @"online";
static NSString * const kStatOpen = @"Open";
static NSString * const kStatOpenActionSheet = @"Open action sheet";
static NSString * const kStatOpenSite = @"Open site";
static NSString * const kStatOpentable = @"OpenTable";
static NSString * const kStatOrientation = @"Orientation";
static NSString * const kStatOther = @"Other";
static NSString * const kStatOut = @"Out";
static NSString * const kStatPedestrian = @"Pedestrian";
static NSString * const kStatPlacement = @"placement";
static NSString * const kStatPlacePage = @"placepage";
static NSString * const kStatPlacePageBannerBlank = @"Placepage_Banner_blank";
static NSString * const kStatPlacePageBannerClick = @"Placepage_Banner_click";
static NSString * const kStatPlacePageBannerError = @"Placepage_Banner_error";
static NSString * const kStatPlacePageBannerShow = @"Placepage_Banner_show";
static NSString * const kStatPlacePageHotelBook = @"Placepage_Hotel_book";
static NSString * const kStatPlacePageHotelDetails = @"Placepage_Hotel_details";
static NSString * const kStatPlacePageHotelFacilities = @"PlacePage_Hotel_Facilities_open";
static NSString * const kStatPlacePageHotelGallery = @"PlacePage_Hotel_Gallery_open";
static NSString * const kStatPlacePageHotelReviews = @"PlacePage_Hotel_Reviews_land";
static NSString * const kStatPlacePageHotelSearch = @"Search.Booking.Com";
static NSString * const kStatPlacePageNonBuilding = @"placepage_nonbuilding";
static NSString * const kStatPlacePageOwnershipButtonClick = @"Placepage_OwnershipButton_click";
static NSString * const kStatPlacePagePreview = @"placepage_preview";
static NSString * const kStatPlacePageRestaurantBook = @"Placepage_Restaurant_book";
static NSString * const kStatPlacePageSponsoredActionButtonClick = @"Placepage_SponsoredActionButton_click";
static NSString * const kStatPlacePageTaxiClick = @"Placepage_Taxi_click";
static NSString * const kStatPlacepageSponsoredError = @"Placepage_SponsoredGallery_error";
static NSString * const kStatPlacepageSponsoredItemSelected = @"Placepage_SponsoredGallery_ProductItem_selected";
static NSString * const kStatPlacepageSponsoredLogoSelected = @"Placepage_SponsoredGallery_LogoItem_selected";
static NSString * const kStatPlacepageSponsoredMoreSelected = @"Placepage_SponsoredGallery_MoreItem_selected";
static NSString * const kStatPlacepageSponsoredOpen = @"Placepage_SponsoredGalleryPage_opened";
static NSString * const kStatPlacepageSponsoredShow = @"Placepage_SponsoredGallery_shown";
static NSString * const kStatPlacepageTaxiShow = @"Placepage_Taxi_show";
static NSString * const kStatPointToPoint = @"Point to point";
static NSString * const kStatPortrait = @"Portrait";
static NSString * const kStatPosition = @"position";
static NSString * const kStatPriceCategory = @"price_category";
static NSString * const kStatProblem = @"Problem";
static NSString * const kStatProfile = @"Profile";
static NSString * const kStatProgress = @"Progress";
static NSString * const kStatProvider = @"Provider";
static NSString * const kStatPublicTransport = @"Public Transport";
static NSString * const kStatPushReceived = @"Push received";
static NSString * const kStatRB = @"RB";
static NSString * const kStatRate = @"Rate";
static NSString * const kStatRating = @"rating";
static NSString * const kStatReason = @"Reason";
static NSString * const kStatRecentTrack = @"Recent track";
static NSString * const kStatRegular = @"Regular";
static NSString * const kStatRemove = @"Remove";
static NSString * const kStatRename = @"Rename";
static NSString * const kStatReport = @"Report";
static NSString * const kStatResort = @"resort";
static NSString * const kStatRestaurant = @"restaurant";
static NSString * const kStatRestaurantLocation = @"restaurant_location";
static NSString * const kStatRetry = @"retry";
static NSString * const kStatRouteManagerClose = @"Routing_RouteManager_close";
static NSString * const kStatRouteManagerOpen = @"Routing_RouteManager_open";
static NSString * const kStatRouteManagerRearrange = @"Routing_RouteManager_rearrange";
static NSString * const kStatRouting = @"routing";
static NSString * const kStatRoutingAddPoint = @"Routing_Point_add";
static NSString * const kStatRoutingBookmarksClicked = @"Routing_Bookmarks_click";
static NSString * const kStatRoutingBuildTaxi = @"Routing_Build_Taxi";
static NSString * const kStatRoutingModeOnRoute = @"onroute";
static NSString * const kStatRoutingModePlanning = @"planning";
static NSString * const kStatRoutingPointMethod = @"method";
static NSString * const kStatRoutingPointMethodApi = @"api";
static NSString * const kStatRoutingPointMethodNoPlanning = @"outside_pp";
static NSString * const kStatRoutingPointMethodPlanning = @"planning_pp";
static NSString * const kStatRoutingPointType = @"type";
static NSString * const kStatRoutingPointTypeFinish = @"finish";
static NSString * const kStatRoutingPointTypeIntermediate = @"inter";
static NSString * const kStatRoutingPointTypeStart = @"start";
static NSString * const kStatRoutingPointValue = @"value";
static NSString * const kStatRoutingPointValueMyPosition = @"gps";
static NSString * const kStatRoutingPointValuePoint = @"point";
static NSString * const kStatRoutingRemovePoint = @"Routing_Point_remove";
static NSString * const kStatRoutingSearchClicked = @"Routing_Search_click";
static NSString * const kStatRoutingTaxiInstall = @"Routing_Taxi_install";
static NSString * const kStatRoutingTaxiOrder = @"Routing_Taxi_order";
static NSString * const kStatRoutingTooltipClicked = @"Routing_PlanTooltip_click";
static NSString * const kStatSave = @"Save";
static NSString * const kStatScenario = @"scenario";
static NSString * const kStatScreen = @"Screen";
static NSString * const kStatSearch = @"search";
static NSString * const kStatSearchAttractions = @"Search.Attractions";
static NSString * const kStatSearchEnteredState = @"Search entered state";
static NSString * const kStatSearchFilterApply = @"Search_Filter_Apply";
static NSString * const kStatSearchFilterCancel = @"Search_Filter_Cancel";
static NSString * const kStatSearchFilterClick = @"Search_Filter_Click";
static NSString * const kStatSearchFilterOpen = @"Search_Filter_Open";
static NSString * const kStatSearchFilterReset = @"Search_Filter_Reset";
static NSString * const kStatSearchRestaurants = @"Search.Restaurants";
static NSString * const kStatSearchSponsoredSelect = @"Search_SponsoredCategory_selected";
static NSString * const kStatSearchSponsoredShow = @"Search_SponsoredCategory_shown";
static NSString * const kStatSelectMap = @"Select map";
static NSString * const kStatSelectResult = @"Select result";
static NSString * const kStatSelectTab = @"Select tab";
static NSString * const kStatSendEmail = @"Send email";
static NSString * const kStatSettings = @"Settings";
static NSString * const kStatSettingsOpenSection = @"Settings open section";
static NSString * const kStatShare = @"Share";
static NSString * const kStatShowBig2SmallMWM = @"Big mwms to small mwms dialog appearing counter";
static NSString * const kStatShowOnMap = @"Show on map";
static NSString * const kStatSignup = @"Signup";
static NSString * const kStatSimplifiedColors = @"Simplified colors scheme";
static NSString * const kStatSocial = @"Social";
static NSString * const kStatSource = @"Source";
static NSString * const kStatSponsor = @"sponsor";
static NSString * const kStatStart = @"Start";
static NSString * const kStatState = @"state";
static NSString * const kStatSwapRoutingPoints = @"Swap routing points";
static NSString * const kStatTTS = @"TTS";
static NSString * const kStatTTSSettings = @"TTS settings";
static NSString * const kStatTable = @"Table";
static NSString * const kStatTags = @"tags";
static NSString * const kStatTaxi = @"Taxi";
static NSString * const kStatThor = @"Thor";
static NSString * const kStatThingsToDo = @"Things to do";
static NSString * const kStatToLocation = @"to_location";
static NSString * const kStatToMyPosition = @"To my position";
static NSString * const kStatToggleBookmark = @"Toggle bookmark";
static NSString * const kStatToggleCompassCalibration = @"Toggle compass calibration";
static NSString * const kStatToggleCoordinates = @"Toggle coordinates";
static NSString * const kStatToggleDownload = @"Toggle download";
static NSString * const kStatToggleLargeFontSize = @"Toggle large fonts size";
static NSString * const kStatToggleSection = @"Toggle section";
static NSString * const kStatToggleStatistics = @"Toggle statistics";
static NSString * const kStatToggleTransliteration = @"Toggle transliteration";
static NSString * const kStatToggleVisibility = @"Toggle visibility";
static NSString * const kStatToggleZoomButtonsVisibility = @"Toggle zoom buttons visibility";
static NSString * const kStatTraffic = @"Traffic";
static NSString * const kStatType = @"type";
static NSString * const kStatUGCReviewAuthDeclined = @"UGC_Auth_declined";
static NSString * const kStatUGCReviewAuthError = @"UGC_Auth_error";
static NSString * const kStatUGCReviewAuthExternalRequestSuccess =
    @"UGC_Auth_external_request_success";
static NSString * const kStatUGCReviewAuthShown = @"UGC_Auth_shown";
static NSString * const kStatUGCReviewCancel = @"UGC_Review_cancel";
static NSString * const kStatUGCReviewError = @"UGC_Review_error";
static NSString * const kStatUGCReviewStart = @"UGC_Review_start";
static NSString * const kStatUGCReviewSuccess = @"UGC_Review_success";
static NSString * const kStatUber = @"Uber";
static NSString * const kStatUnknown = @"unknown";
static NSString * const kStatUnknownError = @"unknown_error";
static NSString * const kStatUpdate = @"update";
static NSString * const kStatUpdateAll = @"update_all";
static NSString * const kStatValue = @"Value";
static NSString * const kStatVehicle = @"Vehicle";
static NSString * const kStatViator = @"Viator.com";
static NSString * const kStatVisible = @"Visible";
static NSString * const kStatWhatsNew = @"What's New";
static NSString * const kStatWifi = @"wifi";
static NSString * const kStatYandex = @"Yandex";
static NSString * const kStatYes = @"Yes";
static NSString * const kStatZoom = @"Zoom";
static NSString * const kStatiPad = @"iPad";
static NSString * const kStatiPhone = @"iPhone";

static inline NSString * const kStatEventName(NSString * component, NSString * action)
{
  return [NSString stringWithFormat:@"%@ %@", component, action];
}

static inline NSString * const makeLocationEventValue(CLLocationDegrees latitude,
                                                      CLLocationDegrees longitude)
{
  return [NSString stringWithFormat:@"%@,%@", @(latitude), @(longitude)];
}
